clear; clc; close all;

dt=0.01;
T_pos=3;
T_trans=1;
Pos_knee=[0,22.5,45,67.5,90]*pi()/180;;
T_total=T_pos*size(Pos_knee,2)+T_trans*(size(Pos_knee,2)-1);

n=T_total/dt;

for i=1:n
    Time(i)=dt*(i-1);
    if Time(i)<T_pos
        Pos(i)=Pos_knee(1);
    elseif Time(i)<(T_pos+T_trans)
        Pos(i)=((Pos_knee(2)-Pos_knee(1))/(T_trans))*(Time(i)-T_pos)+Pos_knee(1);
    elseif Time(i)<(T_pos*2+T_trans)
        Pos(i)=Pos_knee(2);
    elseif Time(i)<(T_pos+T_trans)*2
        Pos(i)=Pos_knee(2)+((Pos_knee(3)-Pos_knee(2))/(T_trans))*(Time(i)-T_pos*2-T_trans);
    elseif Time(i)<((T_pos+T_trans)*2+T_pos)
        Pos(i)=Pos_knee(3);
    elseif Time(i)<(T_pos+T_trans)*3
        Pos(i)=Pos_knee(3)+((Pos_knee(4)-Pos_knee(3))/(T_trans))*(Time(i)-T_pos*3-T_trans*2);
    elseif Time(i)<((T_pos+T_trans)*3+T_pos)
        Pos(i)=Pos_knee(4);
    elseif Time(i)<(T_pos+T_trans)*4
        Pos(i)=Pos_knee(4)+((Pos_knee(5)-Pos_knee(4))/(T_trans))*(Time(i)-T_pos*4-T_trans*3);
    elseif Time(i)<((T_pos+T_trans)*4+T_pos)
        Pos(i)=Pos_knee(5);
    end
end

[Pos_suav,vel,ac]=loess(Time',Pos',100);
Pos_suav=Pos_suav';

figure();hold on; grid on;
plot(Time,Pos,'r')
plot(Time,Pos_suav,'b')
title('Smooted data')

figure();hold on; grid on;
plot(Time,vel,'r')
plot(Time,ac,'b')
legend('Velocidad','Aceleracion');
title('Derivated data')


Resul=[Time',Pos_suav'];
